tree grammar FunctionID;

options{
	tokenVocab = CMinus;
	ASTLabelType = CommonTree;
}

@header{
	import java.util.HashMap;
	import java.util.Vector;
	import java.util.Map;
	import java.io.*;
}

program	:
	 ^(PROGRAM ^(VARIABLES .*) ^(FUNCTIONS funDecl*) .) EOF
	;
	
funDecl
@init{
	Vector params=new Vector();
}
@after{
        CommonTree blockNode = (CommonTree)$funDecl.start.getChild(3);
	Main.symbols.declare_function($name.text,$type.text,params,blockNode);
}
	:	^(FUNCTION type=TYPE name=ID ^(PARAMATERS (par=paramDecl {params.add($par.p);})*) .)// block)
	;

paramDecl returns[FunctionParam p]
	:	^(VARPAR TYPE ID) {$p=new FunctionParam($ID.text,$TYPE.text,"scalar");}
	|	^(ARRPAR TYPE ID) {$p=new FunctionParam($ID.text,$TYPE.text,"array");}
	;
